## freediameter 1.2.1

=== extensions/app_diameap/CMakeLists.txt ===
# The Diameter EAP Application extension
PROJECT("Diameter EAP Application extension" C)

# Find MySQL 
FIND_PACKAGE(MySQL REQUIRED)
FIND_PACKAGE(Gcrypt REQUIRED)
INCLUDE_DIRECTORIES(${MySQL_INCLUDE_DIR})

# Parse plugins
ADD_SUBDIRECTORY(plugins)

# Parser 
BISON_FILE(diameap.y)
FLEX_FILE(diameap.l)
SET_SOURCE_FILES_PROPERTIES(lex.diameap.c diameap.tab.c PROPERTIES COMPILE_FLAGS "-I \"${CMAKE_CURRENT_SOURCE_DIR}\"")


set( diameapsrc
    diameap_defs.h
    diameap.h
    diameap_server.h
    diameap_plugins.h        
    diameap_eap.h
    plugins.h
    diameap_eappacket.h
    diameap_user.h
    diameap.tab.h
    diameap.tab.c
    lex.diameap.c        
    diameap.c
    diameap_server.c
    diameap_plugins.c
    diameap_init.c
    diameap_common.h
    diameap_eappacket.c
    libdiameap.h
    diameap_eap.c
    diameap_mysql.h
    diameap_mysql.c
    diameap_tls.h
    diameap_tls.c
    libcrypt.h
    libcrypt.c
    diameap_user.c
)

FD_ADD_EXTENSION(app_diameap ${diameapsrc})

TARGET_LINK_LIBRARIES(app_diameap ${GCRYPT_LIBRARY} ${GNUTLS_LIBRARIES} ${MySQL_LIBRARY} )

####
## INSTALL section ##

INSTALL(TARGETS app_diameap
	LIBRARY DESTINATION ${INSTALL_EXTENSIONS_SUFFIX}
	COMPONENT freeDiameter-eap-server)

=== extensions/dict_dcca_starent/CMakeLists.txt ===
# The dict_dcca_starent extension
PROJECT("Diameter DCCA (Diameter Credit Control Application) Starent dictionary definitions " C)

# Compile as a module
FD_ADD_EXTENSION(dict_dcca_starent dict_dcca_starent.c)


####
## INSTALL section ##

INSTALL(TARGETS dict_dcca_starent
	LIBRARY DESTINATION ${INSTALL_EXTENSIONS_SUFFIX}
	COMPONENT freeDiameter-dictionary-rfc4006-extension-starent)

=== contrib/PKI/ca_script2/Makefile ===
#!/usr/bin/make -s
#
# This file is inspired from freeDiameter's contrib/ca_script and
# improved to handle multiple CA in a hierarchical fashion.
# Warning: the directory structure is flat, does not reflect the CA hierarchy

SCRIPT_DIR = .
DATA_DIR = ./ca_data

CONFIG = -config $(SCRIPT_DIR)/openssl.cnf
REMAKE = $(MAKE) -f $(SCRIPT_DIR)/Makefile

#Disable "make destroy" -- overwrite on command line
force = 

#RSA key sizes, can be overwritten on command line
cakeysize = 2048
keysize = 1024

# Save current date
DATE=`date +%Y%m%d-%H%M%S`

# Default: print the help
all:	help

# Help message
help:
	@echo "\n\
Available commands:\n\
   make init topca=name\n\
       Creates the initial top-level CA structure\n\
   make newca name=newcaname ca=parentca\n\
       Creates a new sub-CA that can be used for certificates later.\n\
   make newcert name=foo ca=parentca\n\
       Create private key and csr, then issue the certificate (named foo.*)\n\
   make p12 name=foo ca=parentca\n\
       Same as newcert, but additionnaly creates a pkcs12 file to ship client certificate to Windows or Mac\n\
   make ship name=foo ca=parentca\n\
       Create an archive with the data for the client (useful for freeDiameter peers)\n\
   make revoke name=foo ca=parentca\n\
       Revokes the certificate foo.cert issued by parentca and regenerates the CRL.\n\
   make gencrl ca=caname\n\
       Regenerates the CRL of CA caname. Should be run periodically.\n\
\n\
";

# Destroy the CA hierarchy completely. Use with care.
destroy:
	@if [ -z "$(force)" ]; then echo "Destroy disabled, use: make destroy force=y"; exit 1; fi
	@if [ ! -d $(SCRIPT_DIR) ]; then echo "Error in setup"; exit 1; fi
	@echo "Removing everything (for debug purpose)..."
	@rm -rf $(DATA_DIR)/*

# Initialize the CA structure
structure:
	@if [ -z "$(caname)" ]; then echo "Internal error: caname is missing"; exit 1; fi
	@if [ -d $(DATA_DIR)/$(caname) ]; then echo "CA $(caname) already exists."; exit 1; fi
	# Creating CA structure
	@mkdir -p $(DATA_DIR)/$(caname)
	@mkdir $(DATA_DIR)/$(caname)/public
	@mkdir $(DATA_DIR)/$(caname)/public/crl
	@mkdir $(DATA_DIR)/$(caname)/private
	@chmod 700 $(DATA_DIR)/$(caname)/private
	@mkdir $(DATA_DIR)/$(caname)/clients
	@echo "01" > $(DATA_DIR)/$(caname)/serial
	@echo "01" > $(DATA_DIR)/$(caname)/crlnumber
	@touch $(DATA_DIR)/$(caname)/index.txt

# Initialize the top-level CA structure and keys.
init:
	@if [ -z "$(topca)" ]; then echo "Please specify the name of the root CA. Ex: make init topca=rootca.testbed.aaa"; exit 1; fi
	# Create the folder hierarchy
	@$(REMAKE) structure caname=$(topca)
	# Generate the self-signed certificate
	@CA_ROOT_DIR=$(DATA_DIR)/$(topca) openssl req $(CONFIG) -new -batch -x509 -days 3650 -nodes -newkey rsa:$(cakeysize) -out $(DATA_DIR)/$(topca)/public/cacert.pem \
		-keyout $(DATA_DIR)/$(topca)/private/cakey.pem -extensions ca_cert -subj /CN=$(topca)
	@ln -s cacert.pem $(DATA_DIR)/$(topca)/public/`openssl x509 -noout -hash < $(DATA_DIR)/$(topca)/public/cacert.pem`.0
	@touch $(DATA_DIR)/$(topca)/public/cachain.pem
	@ln -s ../../$(topca)/public/cacert.pem $(DATA_DIR)/$(topca)/public/caroot.pem 
	@$(REMAKE) gencrl ca=$(topca)

# Create a secondary CA
newca:
	@if [ -z "$(name)" -o -z "$(ca)" ]; then echo "Missing parameter. Ex: make newca name=subca.testbed.aaa ca=rootca.testbed.aaa"; exit 1; fi
	@if [ ! -e $(DATA_DIR)/$(ca)/private/cakey.pem ]; then echo "The parent CA $(ca) does not exist."; exit 1; fi
	@if [ ! -d $(DATA_DIR)/$(name) ]; then $(REMAKE) structure caname=$(name); fi
	# Generate the private key and CSR for the new CA if needed
	@if [ ! -e $(DATA_DIR)/$(name)/private/cakey.pem ]; then \
		openssl genrsa -out $(DATA_DIR)/$(name)/private/cakey.pem $(cakeysize) ; fi
	@if [ ! -e $(DATA_DIR)/$(name)/private/cacsr.pem ]; then \
		CA_ROOT_DIR=$(DATA_DIR)/$(name) openssl req $(CONFIG) -new -batch -out $(DATA_DIR)/$(name)/private/cacsr.pem \
			-key $(DATA_DIR)/$(name)/private/cakey.pem \
			-subj /CN=$(name) -reqexts v3_req_ca; fi
	# Revoke a previous certificate for this CA if any
	@if [ -e $(DATA_DIR)/$(name)/public/cacert.pem ]; then \
		echo "Revoking previous certificate ..."; \
		$(REMAKE) revoke name=$(name) ca=$(ca); \
		mv $(DATA_DIR)/$(name)/public/cacert.pem $(DATA_DIR)/$(name)/public/cacert-$(DATE).pem; fi
	# Issue the new CA certificate
	@CA_ROOT_DIR=$(DATA_DIR)/$(ca) openssl ca $(CONFIG) -in $(DATA_DIR)/$(name)/private/cacsr.pem \
		-out $(DATA_DIR)/$(name)/public/cacert.pem \
		-batch -extensions ca_cert
	# Hash and link to parent
	@ln -s cacert.pem $(DATA_DIR)/$(ca)/public/`openssl x509 -noout -hash < $(DATA_DIR)/$(name)/public/cacert.pem`.0
	@rm -f $(DATA_DIR)/$(name)/parent
	@ln -s ../$(ca) $(DATA_DIR)/$(name)/parent
	@cat $(DATA_DIR)/$(name)/public/cacert.pem $(DATA_DIR)/$(ca)/public/cachain.pem > $(DATA_DIR)/$(name)/public/cachain.pem
	@ln -s ../../$(ca)/public/caroot.pem $(DATA_DIR)/$(name)/public/caroot.pem
	@for CRLFILE in `cd $(DATA_DIR)/$(ca)/public/crl && ls -1`; do ln -sf ../../../$(ca)/public/crl/$$CRLFILE $(DATA_DIR)/$(name)/public/crl/$$CRLFILE; done
	@$(REMAKE) gencrl ca=$(name)

# Create a new certificate for use in TLS communications and other terminal usages
newcert:
	@if [ -z "$(name)" -o -z "$(ca)" ]; then echo "Missing parameter. Ex: make newcert name=service.testbed.aaa ca=ca.testbed.aaa"; exit 1; fi
	@if [ ! -e $(DATA_DIR)/$(ca)/private/cakey.pem ]; then echo "The parent CA $(ca) does not exist."; exit 1; fi
	@if [ ! -d $(DATA_DIR)/$(ca)/clients/$(name) ]; then mkdir $(DATA_DIR)/$(ca)/clients/$(name); fi
	# Create a private key if needed
	@if [ ! -e $(DATA_DIR)/$(ca)/clients/$(name)/privkey.pem ]; then \
		openssl genrsa -out $(DATA_DIR)/$(ca)/clients/$(name)/privkey.pem $(keysize); fi
	# Create a CSR if needed
	@if [ ! -e $(DATA_DIR)/$(ca)/clients/$(name)/csr.pem ]; then \
		CA_ROOT_DIR=$(DATA_DIR)/$(ca) openssl req $(CONFIG) -new -batch -out $(DATA_DIR)/$(ca)/clients/$(name)/csr.pem \
			-key $(DATA_DIR)/$(ca)/clients/$(name)/privkey.pem \
			-subj /CN=$(name); fi
	# Revoke a previous certificate if any
	@if [ -e $(DATA_DIR)/$(ca)/clients/$(name)/cert.pem ]; then \
		$(REMAKE) revoke name=$(name) ca=$(ca); \
		mv $(DATA_DIR)/$(ca)/clients/$(name)/cert.pem $(DATA_DIR)/$(ca)/clients/$(name)/cert-$(DATE).pem; fi
	# Now sign the new certificate with the CA key
	@CA_ROOT_DIR=$(DATA_DIR)/$(ca) openssl ca $(CONFIG) -in $(DATA_DIR)/$(ca)/clients/$(name)/csr.pem \
		-out $(DATA_DIR)/$(ca)/clients/$(name)/cert.pem \
		-batch
	# Hash
	@ln -sf `cat $(DATA_DIR)/$(ca)/serial.old`.pem $(DATA_DIR)/$(ca)/public/`openssl x509 -noout -hash < $(DATA_DIR)/$(ca)/clients/$(name)/cert.pem`.0
	# Compiled informations for the client
	@cat $(DATA_DIR)/$(ca)/clients/$(name)/cert.pem $(DATA_DIR)/$(ca)/public/cachain.pem > $(DATA_DIR)/$(ca)/clients/$(name)/certchain.pem
	@ln -sf ../../public/crl $(DATA_DIR)/$(ca)/clients/$(name)/crl
	@ln -sf ../../public/caroot.pem $(DATA_DIR)/$(ca)/clients/$(name)/ca.pem

# Create a PKCS#12 file containing the client's information
p12:	newcert
	# Create the PKCS#12 file
	@cat 	$(DATA_DIR)/$(ca)/clients/$(name)/privkey.pem \
		$(DATA_DIR)/$(ca)/clients/$(name)/certchain.pem \
		$(DATA_DIR)/$(ca)/clients/$(name)/ca.pem \
		| openssl pkcs12 -export -out $(DATA_DIR)/$(ca)/clients/$(name)/$(name).p12
	@echo "Client certificate is created in $(DATA_DIR)/$(ca)/clients/$(name)/$(name).p12"

# Create an archive to send the data to the client node
ship:
	@if [ -z "$(name)" -o -z "$(ca)" ]; then echo "Missing parameter. Ex: make ship name=service.testbed.aaa ca=ca.testbed.aaa"; exit 1; fi
	@if [ ! -e $(DATA_DIR)/$(ca)/private/cakey.pem ]; then echo "The parent CA $(ca) does not exist."; exit 1; fi
	@if [ ! -e  $(DATA_DIR)/$(ca)/clients/$(name)/privkey.pem ]; then echo "The client $(name) does not exist, use 'make newcert' first."; exit 1; fi
	# Ship the data
	@tar -c -C $(DATA_DIR)/$(ca)/clients/$(name) -z -f $(ca)_$(name).tar.gz -h .
	@echo "The files have been packaged into archive: $(ca)_$(name).tar.gz"

# Revoke a certificate
revoke:
	@if [ -z "$(name)" -o -z "$(ca)" ]; then echo "Missing parameter. Ex: make revoke name=service.testbed.aaa ca=ca.testbed.aaa"; exit 1; fi
	@if [ ! -e $(DATA_DIR)/$(ca)/private/cakey.pem ]; then echo "The parent CA $(ca) does not exist."; exit 1; fi
	@if [ ! -e $(DATA_DIR)/$(ca)/clients/$(name)/cert.pem ]; \
		then echo "$(DATA_DIR)/$(ca)/clients/$(name)/cert.pem not found"; \
		exit 1; \
		fi;
	# Revoke the certificate
	@CA_ROOT_DIR=$(DATA_DIR)/$(ca) openssl ca $(CONFIG) -revoke $(DATA_DIR)/$(ca)/clients/$(name)/cert.pem;
	@$(REMAKE) gencrl ca=$(ca)

# Regenerate the Certificate Revocation List.
gencrl:
	@if [ -z "$(ca)" ]; then echo "Missing parameter. Ex: make gencrl ca=ca.testbed.aaa"; exit 1; fi
	# Create the CRL
	@CA_ROOT_DIR=$(DATA_DIR)/$(ca) openssl ca $(CONFIG) -gencrl -out $(DATA_DIR)/$(ca)/public/crl/$(ca).pem
	@ln -s crl/$(ca).pem $(DATA_DIR)/$(ca)/public/local.pem
	@ln -s local.pem $(DATA_DIR)/$(ca)/public/`openssl crl -noout -hash < $(DATA_DIR)/$(ca)/public/crl/$(ca).pem`.r0

# End of file...

=== extensions/app_diameap/plugins/CMakeLists.txt ===
PROJECT("EAP Methods Plugins" C)

MACRO(EAP_ADD_METHOD METHNAME)
  ADD_LIBRARY(${METHNAME} MODULE ${ARGN})
  SET_TARGET_PROPERTIES(${METHNAME} PROPERTIES PREFIX "" )
  SET_TARGET_PROPERTIES(${METHNAME} PROPERTIES SUFFIX ".emp" )
  INSTALL(TARGETS ${METHNAME}
	LIBRARY DESTINATION ${INSTALL_EXTENSIONS_SUFFIX}
	COMPONENT freeDiameter-eap-server)
ENDMACRO(EAP_ADD_METHOD)

# Use the macro FD_EAP_PLUGIN(extmacroname subdir descr default) to 
# add a new extension subdirectory.
MACRO(FD_EAP_PLUGIN EXTSUBDIR EXTDESCR EXTDEFAULT)
   STRING(TOUPPER ${EXTSUBDIR} EXTMACRONAME)
   IF (NOT ALL_EXTENSIONS)
     OPTION(BUILD_${EXTMACRONAME} ${EXTDESCR} ${EXTDEFAULT})
   ENDIF (NOT ALL_EXTENSIONS)
   IF (BUILD_${EXTMACRONAME} OR ALL_EXTENSIONS)
      ADD_SUBDIRECTORY(${EXTSUBDIR})
   ENDIF (BUILD_${EXTMACRONAME} OR ALL_EXTENSIONS)
ENDMACRO(FD_EAP_PLUGIN)

###########################
# EAP Methods Plugins Section

# EAP Identity plugin
FD_EAP_PLUGIN(eap_identity "Build EAP Identity Plugin " ON)

# EAP MD5 plugin
FD_EAP_PLUGIN(eap_md5 "Build EAP-MD5 Plugin " OFF)

# EAP TLS plugin
FD_EAP_PLUGIN(eap_tls "Build EAP-TLS Plugin " OFF)

=== debian/changelog ===
freediameter (1.2.1-8) unstable; urgency=medium

  * Team upload
  * CVE-2020-6098 (Closes: #985088)
    Anybody can send a specially crafted Diameter request, which triggers
    a memory corruption and thus results in a denial-of-service.

 -- Thorsten Alteholz <debian@alteholz.de>  Mon, 22 Mar 2021 18:03:02 +0100

freediameter (1.2.1-7) unstable; urgency=medium

  * Build using "old" SCTP API since the new one fails to build in Debian
    unstable (Closes: #910440)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 14 Oct 2018 10:26:18 +0200

freediameter (1.2.1-6) unstable; urgency=medium

  * debian/rules:
    - Test suite fails randomly on more architectures, so skipping entirely

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 04 Sep 2018 19:51:42 +0200

freediameter (1.2.1-5) unstable; urgency=medium

  * debian/rules:
    - skip test suite on s390x because of problems with the test suite

 -- Ruben Undheim <ruben.undheim@gmail.com>  Tue, 04 Sep 2018 07:00:51 +0200

freediameter (1.2.1-4) unstable; urgency=medium

  * debian/control:
    - Added more dependencies for libfreediameter-dev:
        libgnutls28-dev, libgcrypt20-dev, libidn11-dev, libsctp-dev
    - 'freediameter' changed to arch: all and Multi-Arch: foreign.

 -- Ruben Undheim <ruben.undheim@gmail.com>  Mon, 03 Sep 2018 22:13:39 +0200

freediameter (1.2.1-3) unstable; urgency=medium

  * debian/*.install:
    - Move freeDiameter.conf from libfdcore6 to freediameterd.
  * debian/control:
    - freediameter now "Multi-Arch: same"
    - libfreediameter-dev not "Multi-Arch: same" anymore because of
      freeDiameter-host.h
    - Handle moved file using Breaks and Replaces
  * debian/tests/control:
    - Test depends on "build-essential"

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 02 Sep 2018 20:32:05 +0200

freediameter (1.2.1-2) unstable; urgency=medium

  * d/patches/0004-Disable-running-tests-that-require-the-kernel-module.patch:
    - Fix FTBFS because of build machine not having loaded the 'sctp' kernel
      module
  * d/control:
    - New standards version 4.2.1 - no changes

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sun, 26 Aug 2018 10:41:29 +0200

freediameter (1.2.1-1) unstable; urgency=low

  * Initial release (Closes: #904219)

 -- Ruben Undheim <ruben.undheim@gmail.com>  Sat, 25 Aug 2018 14:49:27 +0200

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CHANGELOG_DATE ?= $(shell LC_ALL=C date -u -d @$(SOURCE_DATE_EPOCH) +"%d %B %Y")

arch = $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_INSTALL_DIR=lib/$(DEB_HOST_MULTIARCH)

override_dh_strip:
	dh_strip
	strip --remove-section=.comment debian/freediameter-extensions/usr/lib/freeDiameter/*

override_dh_installchangelogs:
	dh_installchangelogs contrib/debian/changelog

override_dh_installman:
	cd debian/man ; CHANGELOG_DATE="$(CHANGELOG_DATE)" ./genmanpages.sh
	dh_installman

override_dh_auto_clean:
	dh_auto_clean
	$(RM) debian/man/*.1

# Skip unreliable tests:
override_dh_auto_test:
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#	echo ${arch}
#	if [ "${arch}" = "s390x" ] ; then \
#	   echo "Do not care of test result on this architecture. There seems to be some serious problems with the test suite in general, but it only causes FTBFS on s390x" ;\
#	else \
#	   echo "Do run tests on this architecture" ;\
#	   dh_auto_test ;\
#	fi
#endif

=== debian/tests/control ===
Tests: can-link
Depends: libfreediameter-dev, build-essential

## freediameter 1.5.0

=== extensions/app_diameap/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,25 @@
 # The Diameter EAP Application extension
 PROJECT("Diameter EAP Application extension" C)
+
+INCLUDE (CheckCSourceCompiles)
 
 # Find MySQL 
 FIND_PACKAGE(MySQL REQUIRED)
 FIND_PACKAGE(Gcrypt REQUIRED)
 INCLUDE_DIRECTORIES(${MySQL_INCLUDE_DIR})
+
+# Check for my_bool, deprecated in MySQL 8.0
+SET(CHECK_MYSQL_MY_BOOL "
+#include <mysql.h>
+int main() {
+my_bool f;
+}")
+SET(CMAKE_REQUIRED_INCLUDES ${MySQL_INCLUDE_DIR})
+SET(CMAKE_REQUIRED_LIBRARIES ${MySQL_LIBRARY})
+CHECK_C_SOURCE_COMPILES("${CHECK_MYSQL_MY_BOOL}" HAVE_MYSQL_MY_BOOL)
+IF (HAVE_MYSQL_MY_BOOL)
+  ADD_DEFINITIONS(-DHAVE_MYSQL_MY_BOOL)
+ENDIF()
 
 # Parse plugins
 ADD_SUBDIRECTORY(plugins)

=== extensions/dbg_interactive/CMakeLists.txt ===
# The dbg_interactive extension
PROJECT("Interactive debug facility based on SWIG" C)


# This module is using Python
SET(Python_ADDITIONAL_VERSIONS 2.7 2.6 2.5 2.4 2.3 2.2 2.1 2.0)
FIND_PACKAGE(PythonLibs)
INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})

##### 
# Wrapper to fD in python
FIND_PACKAGE(SWIG REQUIRED)
INCLUDE(${SWIG_USE_FILE})
SET(CMAKE_SWIG_FLAGS -castmode -threads)

# Add the dependencies for re-swig-ing the file
SET(SWIG_MODULE_fDpy_EXTRA_DEPS 
	${CMAKE_BINARY_DIR}/include/freeDiameter/freeDiameter-host.h 
	${CMAKE_SOURCE_DIR}/include/freeDiameter/libfdcore.h 
	${CMAKE_SOURCE_DIR}/include/freeDiameter/libfdproto.h 
	lists.i
	dictionary.i
	sessions.i
	routing.i
	messages.i
	dispatch.i
	queues.i
	peers.i
	events.i
	endpoints.i
	posix.i
	hooks.i
	)
SET_SOURCE_FILES_PROPERTIES(dbg_interactive.i PROPERTIES SWIG_MODULE_NAME fDpy)

# The following code is inspired from SWIG_ADD_MODULE, but we do only what we need
SWIG_MODULE_INITIALIZE(fDpy python)
SWIG_ADD_SOURCE_TO_MODULE(fDpy swig_generated_sources "dbg_interactive.i")
	
# In order to avoid shipping the python file that contains the shadow class definitions, 
# we transform this file in a C-style string and compile it within our software.
# We use for this purpose xxd tool provided with vim package.
FIND_PROGRAM(XXD_EXECUTABLE xxd)
# To avoid the dependency, simply compile it if not provided
if (NOT XXD_EXECUTABLE) 
   SET_SOURCE_FILES_PROPERTIES(helper/xxd.c PROPERTIES COMPILE_DEFINITIONS UNIX)
   ADD_EXECUTABLE(xxd helper/xxd.c)
   SET(XXD_EXECUTABLE xxd)
endif (NOT XXD_EXECUTABLE) 
# And now the magic command
ADD_CUSTOM_COMMAND(
    OUTPUT "fDpy-inc.c"
    COMMAND "${XXD_EXECUTABLE}"
    ARGS "-i"
    "fDpy.py"
    "fDpy-inc.c"
    MAIN_DEPENDENCY "${swig_extra_generated_files}"
    COMMENT "Shadow definitions") 

# Ensure that the generated source files are removed
GET_DIRECTORY_PROPERTY(swig_extra_clean_files ADDITIONAL_MAKE_CLEAN_FILES)
SET_DIRECTORY_PROPERTIES(PROPERTIES
        ADDITIONAL_MAKE_CLEAN_FILES "${swig_extra_clean_files};${swig_generated_sources};fDpy-inc.c")


#####
# Extension that embeds the python interpreter
FD_ADD_EXTENSION(dbg_interactive dbg_interactive.c ${swig_generated_sources} fDpy-inc.c)
TARGET_LINK_LIBRARIES(dbg_interactive ${PYTHON_LIBRARIES})


####
## INSTALL section ##

INSTALL(TARGETS dbg_interactive
	LIBRARY DESTINATION ${INSTALL_EXTENSIONS_SUFFIX}
	COMPONENT freeDiameter-debug-tools)

=== extensions/dict_rfc5777/CMakeLists.txt ===
# The dict_rfc5777 extension
PROJECT("Traffic Classification and Quality of Service (QoS) Attributes for Diameter (RFC 5777)" C)

# Compile as a module
FD_ADD_EXTENSION(dict_rfc5777 dict_rfc5777.c)


####
## INSTALL section ##

INSTALL(TARGETS dict_rfc5777
	LIBRARY DESTINATION ${INSTALL_EXTENSIONS_SUFFIX}
	COMPONENT freeDiameter-dictionary-RFC5777)

=== extensions/rt_deny_by_size/CMakeLists.txt ===
# The rt_deny_by_size extension
PROJECT("Routing extension to deny messages that are over a particular size" C)

# Parser files
BISON_FILE(rt_deny_by_size_conf.y)
FLEX_FILE(rt_deny_by_size_conf.l)
SET_SOURCE_FILES_PROPERTIES(lex.rt_deny_by_size_conf.c rt_deny_by_size_conf.tab.c PROPERTIES COMPILE_FLAGS "-I ${CMAKE_CURRENT_SOURCE_DIR}")

# List of source files
SET( RT_DENY_BY_SIZE_SRC
	rt_deny_by_size.c
	rt_deny_by_size.h
	lex.rt_deny_by_size_conf.c
	rt_deny_by_size_conf.tab.c
	rt_deny_by_size_conf.tab.h
)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

# Compile these files as a freeDiameter extension
FD_ADD_EXTENSION(rt_deny_by_size ${RT_DENY_BY_SIZE_SRC})

####
## INSTALL section ##

# We install with the daemon component because it is a base feature.
INSTALL(TARGETS rt_deny_by_size
	LIBRARY DESTINATION ${INSTALL_EXTENSIONS_SUFFIX}
	COMPONENT freeDiameter-daemon)

=== extensions/test_netemul/CMakeLists.txt ===
# The test_netemul extension
PROJECT("Simple Diameter network emulator proxy extension (latency, PDV, duplicates)" C)

# Parser files
BISON_FILE(test_netemul.y)
FLEX_FILE(test_netemul.l)
SET_SOURCE_FILES_PROPERTIES(lex.test_netemul.c test_netemul.tab.c PROPERTIES COMPILE_FLAGS "-I ${CMAKE_CURRENT_SOURCE_DIR}")

# List of source files
SET( TNEMUL_SRC
	test_netemul.c
	test_netemul.h
	lex.test_netemul.c
	test_netemul.tab.c
	test_netemul.tab.h
	tne_process.c
)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})

# Compile these files as a freeDiameter extension
FD_ADD_EXTENSION(test_netemul ${TNEMUL_SRC})


# math functions
CHECK_FUNCTION_EXISTS (sqrt HAVE_SQRT)
IF (HAVE_SQRT)
   SET(MATH_LIBS "")
ELSE (HAVE_SQRT)
   CHECK_LIBRARY_EXISTS (m sqrt "" HAVE_LIBM)
   IF (HAVE_LIBM)
     SET(MATH_LIBS "-lm")
   ENDIF (HAVE_LIBM)
ENDIF (HAVE_SQRT)

TARGET_LINK_LIBRARIES(test_netemul ${MATH_LIBS})

####
## INSTALL section ##

INSTALL(TARGETS test_netemul
	LIBRARY DESTINATION ${INSTALL_EXTENSIONS_SUFFIX}
	COMPONENT freeDiameter-debug-tools)

=== contrib/PKI/ca_script/Makefile ===
#!/usr/bin/make -s
#
# This file is designed to automatize the CA tasks such as:
#  -> init  : create the initial CA tree and the CA root certificate.
#  -> newcsr: create a new private key and csr. $name and $email must be set. C, ST, L, O, OU may be overwitten (example: make newcsr C=FR)
#  -> cert  : sign a pending CSR and generate the certificate. $name must be provided.
#  -> revoke: revoke a certificate. $name must be provided.
#  -> gencrl: update/create the CRL.
#
# The file should be located in the directory STATIC_DIR as defined below.
# The DIR directory will contain the data of the CA. It might be placed in /var.
# The DIR should also be configured in openssl.cnf file under [ CA_default ]->dir.
#
# Here are the steps to install the CA scripts in default environment:
## mkdir /etc/openssl-ca.static
## cp Makefile openssl.cnf /etc/openssl-ca.static
# ( configure the default parameters of your CA in /etc/openssl-ca/openssl.cnf ) ##
## mkdir /etc/openssl-ca
## make -f /etc/openssl-ca.static/Makefile destroy force=y
## cd /etc/openssl-ca
## make init
## make help

DIR = /home/thedoc/testbed.aaa/ca
STATIC_DIR = /home/thedoc/testbed.aaa/ca
CONFIG = -config $(DIR)/openssl.cnf

#Defaults for new CSR
C = JP
ST = Tokyo
L = Koganei
O = WIDE
OU = "AAA WG"

#Default lifetime
DAYS = 365

#Values for the CA
CA_CN = mgr.testbed.aaa
CA_mail = sdecugis@freediameter.net

#Disable "make destroy"
force = 


# Default: print the help
all:	help

# Help message
help:
	@echo "\n\
Default values (can be overwritten on command-line):\n\
   [C=$(C)] [ST=$(ST)] [L=$(L)] [O=$(O)] [OU=$(OU)]\n\
   [CA_CN=$(CA_CN)] [CA_mail=$(CA_mail)]\n\n\
Available commands:\n\
   make init\n\
       Creates the initial CA structure in $(DIR)\n\
   make gencrl\n\
       Regenerates the CRL. Should be run at least once a month.\n\
   make newcsr name=foo email=b@r [type=ca]\n\
       Create private key and csr in clients subdir (named foo.*)\n\
   make cert name=foo\n\
       Signs the CSR foo.csr and creates the certificate foo.cert.\n\
   make revoke name=foo\n\
       Revokes the certificate foo.cert and regenerates the CRL.\n\
\n\
Notes:\n\
   Content from public-www should be available from Internet. \n\
   The URL to CRL should be set in openssl.cnf.\n\
   A cron job should execute make gencrl once a month.\n\
";

# Destroy the CA completely. Use with care.
destroy:
	@if [ -z "$(force)" ]; then echo "Restart disabled, use: make destroy force=y"; exit 1; fi
	@if [ ! -d $(STATIC_DIR) ]; then echo "Error in setup"; exit 1; fi
	@echo "Removing everything (for debug purpose)..."
	@rm -rf $(DIR)/*
	@ln -sf $(STATIC_DIR)/Makefile $(DIR)
	@ln -sf $(STATIC_DIR)/openssl.cnf $(DIR)

# Initialize the CA structure and keys.
init:
	@if [ -d $(DIR)/private ]; then echo "CA already initialized."; exit 1; fi
	@echo "Creating CA structure..."
	@mkdir $(DIR)/crl
	@mkdir $(DIR)/certs
	@mkdir $(DIR)/newcerts
	@mkdir $(DIR)/public-www
	@mkdir $(DIR)/private
	@chmod 700 $(DIR)/private
	@mkdir $(DIR)/clients
	@mkdir $(DIR)/clients/privkeys
	@mkdir $(DIR)/clients/csr
	@mkdir $(DIR)/clients/certs
	@echo "01" > $(DIR)/serial
	@touch $(DIR)/index.txt
	@openssl req $(CONFIG) -new -batch -x509 -days 3650 -nodes -newkey rsa:2048 -out $(DIR)/public-www/cacert.pem \
		-keyout $(DIR)/private/cakey.pem -subj /C=$(C)/ST=$(ST)/L=$(L)/O=$(O)/OU=$(OU)/CN=$(CA_CN)/emailAddress=$(CA_mail)
	@ln -s $(DIR)/public-www/cacert.pem $(DIR)/certs/`openssl x509 -noout -hash < $(DIR)/public-www/cacert.pem`.0
	@$(MAKE) -f $(DIR)/Makefile gencrl

# Regenerate the Certificate Revocation List.
# This list should be available publicly
gencrl:
	@openssl ca $(CONFIG) -gencrl -out $(DIR)/public-www/crl.pem
	@ln -sf $(DIR)/public-www/crl.pem $(DIR)/crl/`openssl crl -noout -hash < $(DIR)/public-www/crl.pem`.r0

# Create a new private key and a CSR, in case the client does not provide the CSR by another mean.
# Usage is: make newcsr name=peer.client.fqdn email=admin@client.fqdn
newcsr:
	@if [ -z "$(name)" -o -z "$(email)" ]; then echo "Please provide certificate name and email address: make newcsr name=mn.nautilus.org email=you@mail.com"; exit 1; fi
	@if [ -e $(DIR)/clients/csr/$(name).csr ]; then echo "There is already a pending csr for this name."; exit 1; fi
	@if [ ! -e $(DIR)/clients/privkeys/$(name).key.pem ]; \
		then echo "Generating a private key for $(name) ..."; \
		openssl genrsa -out $(DIR)/clients/privkeys/$(name).key.pem 1024; \
		fi;
	@echo "Creating the CSR in $(DIR)/clients/csr/$(name).csr";
	@openssl req $(CONFIG) -new -batch -out $(DIR)/clients/csr/$(name).csr \
		-key $(DIR)/clients/privkeys/$(name).key.pem \
		-subj /C=$(C)/ST=$(ST)/L=$(L)/O=$(O)/OU=$(OU)/CN=$(name)/emailAddress=$(email)

# Process a CSR to create a x509 certificate. The certificate is valid for 1 year. 
# It should be sent to the client by any mean.
cert:
	@if [ -z "$(name)" ]; then echo "name must be provided: make cert name=mn.n6.org"; exit 1; fi
	@if [ ! -e $(DIR)/clients/csr/$(name).csr ]; then echo "Could not find CSR in $(DIR)/clients/csr/$(name).csr."; exit 1; fi
	@if [ -e $(DIR)/clients/certs/$(name).cert ]; \
		then echo "Revoking old certificate..."; \
		$(MAKE) revoke name=$(name); \
		fi;
	@openssl ca $(CONFIG) -in $(DIR)/clients/csr/$(name).csr \
		-out $(DIR)/clients/certs/$(name).cert \
		-days $(DAYS) \
		-batch
	@ln -s $(DIR)/clients/certs/$(name).cert $(DIR)/certs/`openssl x509 -noout -hash < $(DIR)/clients/certs/$(name).cert`.0

# Revoke a certificate.
revoke:
	@if [ -z "$(name)" ]; then echo "name must be provided: make revoke name=mn.n6.org"; exit 1; fi
	@if [ ! -e $(DIR)/clients/certs/$(name).cert ]; \
		then echo "$(DIR)/clients/certs/$(name).cert not found"; \
		exit 1; \
		fi;
	@openssl ca $(CONFIG) -revoke $(DIR)/clients/certs/$(name).cert;
	@rm -f $(DIR)/certs/`openssl x509 -noout -hash < $(DIR)/clients/certs/$(name).cert`.0
	@$(MAKE) gencrl

# End of file...

=== contrib/PKI/ca_script2/Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 # Help message
 help:
-	@echo "\n\
+	@printf -- "\n\
 Available commands:\n\
    make init topca=name\n\
        Creates the initial top-level CA structure\n\
@@ -172,7 +172,7 @@
 	@if [ -z "$(ca)" ]; then echo "Missing parameter. Ex: make gencrl ca=ca.testbed.aaa"; exit 1; fi
 	# Create the CRL
 	@CA_ROOT_DIR=$(DATA_DIR)/$(ca) openssl ca $(CONFIG) -gencrl -out $(DATA_DIR)/$(ca)/public/crl/$(ca).pem
-	@ln -s crl/$(ca).pem $(DATA_DIR)/$(ca)/public/local.pem
-	@ln -s local.pem $(DATA_DIR)/$(ca)/public/`openssl crl -noout -hash < $(DATA_DIR)/$(ca)/public/crl/$(ca).pem`.r0
+	@ln -f -s crl/$(ca).pem $(DATA_DIR)/$(ca)/public/local.pem
+	@ln -f -s local.pem $(DATA_DIR)/$(ca)/public/`openssl crl -noout -hash < $(DATA_DIR)/$(ca)/public/crl/$(ca).pem`.r0
 
 # End of file...

=== debian/changelog ===
freediameter (1.5.0-2) unstable; urgency=medium

  * fix gcc15 build (Closes: #1096650)

 -- Victor Seva <vseva@debian.org>  Thu, 11 Sep 2025 21:26:29 +0200

freediameter (1.5.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Remove obsolete field Name from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Remove constraints unnecessary since buster (oldstable)

  [ Thorsten Alteholz ]
  * add salsa-ci.yml

  [ Helmut Grohne ]
  * Fix FTCBFS: Use the host architecture strip. (Closes: #985796)

  [ Vagrant Cascadian ]
  * debian/rules: fix reproducible build (Closes: #1001854)

  [ Victor Seva ]
  * debian: add watch file
  * debian: repository is now in github
  * wrap-and-sort -sat
  * gbp.conf: don't import .github files
  * gbp.conf: use [debian|upstream]/latest following DEP-14
  * Use secure URI in Homepage field.
  * New upstream version 1.5.0
  * refresh and remove patches
  * add myself as uploader
  * update symbols
  * pkg-config => pkgconf
  * update manpage with new options
  * remove explicit dependency on freediameter-extensions

  [ Simon Josefsson ]
  * Depend on libidn-dev instead of libidn11-dev. Closes: #1066848.

 -- Victor Seva <vseva@debian.org>  Fri, 31 Jan 2025 17:21:14 +0100

=== debian/control ===
Source: freediameter
Maintainer: Debian Mobcom Maintainers <Debian-mobcom-maintainers@lists.alioth.debian.org>
Uploaders:
 Ruben Undheim <ruben.undheim@gmail.com>,
 Victor Seva <vseva@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 bison,
 cmake,
 debhelper-compat (= 13),
 flex,
 libgcrypt20-dev,
 libgnutls28-dev,
 libidn-dev,
 libsctp-dev,
 pkgconf,
 txt2man,
Standards-Version: 4.2.1
Vcs-Browser: https://salsa.debian.org/debian-mobcom-team/freediameter
Vcs-Git: https://salsa.debian.org/debian-mobcom-team/freediameter.git
Homepage: https://www.freediameter.net/trac/

Package: libfdproto6
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: Library for manipulating Diameter messages and dictionary
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol
 .
 The shared library libfdproto provides the functions to manipulate Diameter
 messages and dictionary. This library is meant to be re-used by other projects
 that would require parsing or manipulating Diameter messages.

Package: libfdcore6
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Multi-Arch: same
Description: FreeDiameter - library for the Diameter protocol
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol.
 .
 This shared library contains the core of the framework. It establishes the
 network connections with other Diameter peers and performs the tasks described
 in Diameter Base Protocol, such as watchdogs, basic routing, ... It also
 handles the loading of extensions (see below)

Package: libfreediameter-dev
Architecture: any
Section: libdevel
Depends:
 libfdcore6 (= ${binary:Version}),
 libfdproto6 (= ${binary:Version}),
 libgcrypt20-dev,
 libgnutls28-dev,
 libidn-dev,
 libsctp-dev,
 ${misc:Depends},
Description: Library for the Diameter protocol (development files)
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol.
 .
 This shared library contains the development files for libfdcoreX and
 libfdprotoX

Package: freediameterd
Architecture: any
Section: utils
Depends:
 libfdcore6 (= ${binary:Version}),
 libfdproto6 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Daemon for the Diameter protocol
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol.
 .
 This simple daemon parses the command line and initializes the freeDiameter
 framework. Use it for your Diameter server & agent components.  In case of
 Diameter clients, you probably will prefer linking the libfdcore directly with
 your client application that must be made Diameter-aware.

Package: freediameter-extensions
Architecture: any
Depends:
 libfdcore6 (= ${binary:Version}),
 libfdproto6 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Extensions for the Diameter protocol
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol.
 .
 The extensions provide the mean to augment the features of the freeDiameterd
 framework. Extensions can provide the handling of a Diameter server
 application, but also advanced routing features, peer management, etc.

Package: freediameter
Architecture: all
Section: utils
Depends:
 freediameter-extensions,
 freediameterd,
 ${misc:Depends},
Multi-Arch: foreign
Description: Implementation of the freeDiameter protocol - metapackage
 Diameter is a protocol designed to carry Authentication, Authorization and
 Accounting (AAA) payload. It is an evolution of the RADIUS protocol (as the
 name suggests).
 .
 freeDiameter is an implementation of the Diameter protocol.
 .
 This is a metapackage which will install the shared libraries, the daemon
 and the extensions for freeDiameter.
